## rhash 1.2.6

=== Makefile ===
# Samples of usage:
# compile with debug info: make OPTFLAGS=-g OPTLDFLAGS= TARGET=rhash.debug
# compile for pentiumpro: make OPTFLAGS="-O2 -DNDEBUG -march=i586 -mcpu=pentiumpro -fomit-frame-pointer"
# create rpm with statically linked program: make rpm LDFLAGS="-Llibrhash -lrhash -static -s -Wl,--gc-sections"
CC      = gcc
VERSION = 1.2.6
PREFIX  = /usr/local
OPTFLAGS = -O2 -DNDEBUG -fomit-frame-pointer -ffunction-sections -fdata-sections
#DEFFLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -ffunction-sections -fdata-sections
ADDCFLAGS =
ADDLDFLAGS =
CFLAGS  := -pipe $(OPTFLAGS) $(ADDCFLAGS) \
  -Wall -W -Wstrict-prototypes -Wnested-externs -Winline -Wpointer-arith \
  -Wbad-function-cast -Wmissing-prototypes -Wmissing-declarations
OPTLDFLAGS = -s
LDFLAGS = -Llibrhash -lrhash $(OPTLDFLAGS) $(ADDLDFLAGS)
HEADERS = calc_sums.h crc_print.h common_func.h crc_update.h file_mask.h file_set.h find_file.h output.h parse_cmdline.h rhash_main.h win_utils.h version.h
SOURCES = calc_sums.c crc_print.c common_func.c crc_update.c file_mask.c file_set.c find_file.c output.c parse_cmdline.c rhash_main.c win_utils.c
OBJECTS = calc_sums.o crc_print.o common_func.o crc_update.o file_mask.o file_set.o find_file.o output.o parse_cmdline.o rhash_main.o win_utils.o
OUTDIR   =
PROGNAME = rhash
TARGET   = $(OUTDIR)$(PROGNAME)
SYMLINKS = sfv-hash tiger-hash tth-hash whirlpool-hash has160-hash gost-hash ed2k-link magnet-link
SPECFILE = $(PROGNAME).spec
LIN_DIST_FILES = Makefile ChangeLog INSTALL COPYING README $(SPECFILE) $(SPECFILE).in \
  $(SOURCES) $(HEADERS) tests/test_rhash.sh rhash.1 rhash.1.win.sed rhash.1.html rhash.1.txt
WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
WIN_SRC_FILES  = win32/dirent.h win32/stdint.h win32/unistd.h win32/platform-dependent.h \
  win32/vc-2010/rhash.vcxproj
LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
  librhash/byte_order.c librhash/byte_order.h librhash/timing.c librhash/timing.h \
  librhash/plug_openssl.c librhash/plug_openssl.h librhash/rhash.c librhash/rhash.h \
  librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
  librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
  librhash/gost.c librhash/gost.h librhash/has160.c librhash/has160.h \
  librhash/hex.c librhash/hex.h librhash/md4.c librhash/md4.h librhash/md5.c librhash/md5.h \
  librhash/ripemd-160.c librhash/ripemd-160.h librhash/sha1.c librhash/sha1.h \
  librhash/sha256.c librhash/sha256.h librhash/sha512.c librhash/sha512.h \
  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h \
  librhash/tiger_sbox.c librhash/tth.c librhash/tth.h librhash/whirlpool.c \
  librhash/whirlpool.h librhash/whirlpool_sbox.c librhash/test_sums.c \
  librhash/test_sums.h librhash/torrent.h librhash/torrent.c \
  librhash/util.c librhash/util.h librhash/config.h librhash/Makefile
DIST_FILES     = $(LIN_DIST_FILES) $(LIBRHASH_FILES) $(WIN_DIST_FILES) $(WIN_SRC_FILES)
WIN_SUFFIX     = win32
ARCHIVE_BZIP   = rhash-$(VERSION)-src.tar.bz2
ARCHIVE_GZIP   = rhash-$(VERSION)-src.tar.gz
ARCHIVE_DEB_GZ = ../rhash_$(VERSION).orig.tar.gz
ARCHIVE_7Z     = rhash-$(VERSION)-src.tar.7z
ARCHIVE_ZIP    = rhash-$(VERSION)-$(WIN_SUFFIX).zip
WIN_ZIP_DIR    = RHash-$(VERSION)-$(WIN_SUFFIX)
DESTDIR = 
BINDIR  = $(PREFIX)/bin
MANDIR  = $(PREFIX)/share/man
RPMTOP  = rpms
RPMDIRS = SOURCES SPECS BUILD SRPMS RPMS
LIBRHASH = librhash/librhash.a
# Set variables according to GNU coding standard
INSTALL = install
INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644

all: $(TARGET)
install: install-program install-symlinks
uninstall: uninstall-program uninstall-symlinks
check: check-version

# creating archives
dist: gzip
gzip: check-version $(ARCHIVE_GZIP)
bzip: check-version $(ARCHIVE_BZIP)
7z:   check-version $(ARCHIVE_7Z)
zip : $(ARCHIVE_ZIP)
win-dist : $(ARCHIVE_ZIP)

install-program: all
	$(INSTALL) -d $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man1 $(DESTDIR)/etc
	$(INSTALL_PROGRAM) $(TARGET) $(DESTDIR)$(BINDIR)
	$(INSTALL_DATA) rhash.1 $(DESTDIR)$(MANDIR)/man1/rhash.1
	sed -e 's/\x0D//g' dist/rhashrc.sample > rhashrc && $(INSTALL_DATA) rhashrc $(DESTDIR)/etc/rhashrc
	rm -f rhashrc

install-symlinks:
	test -x $(DESTDIR)$(BINDIR)/$(PROGNAME)
	for f in $(SYMLINKS); do ln -s rhash $(DESTDIR)$(BINDIR)/$$f; done
	cd $(DESTDIR)$(MANDIR)/man1 && for f in $(SYMLINKS); do ln -s rhash.1* $$f.1; done

uninstall-program:
	rm -f $(DESTDIR)$(BINDIR)/$(PROGNAME)
	rm -f $(DESTDIR)$(MANDIR)/man1/rhash.1

uninstall-symlinks:
	for f in $(SYMLINKS); do rm -f $(DESTDIR)$(BINDIR)/$$f; done

install-lib-static:
	cd librhash && make install-lib-static

install-lib-shared:
	cd librhash && make install-lib-shared

lib-static: $(LIBRHASH)

lib-shared :
	cd librhash && make lib-shared

test-hashes:
	cd librhash && make test

test: $(TARGET) test-hashes
	chmod +x tests/test_$(PROGNAME).sh
	tests/test_$(PROGNAME).sh

version.h : Makefile
	echo "#define VERSION \"$(VERSION)\"" > version.h

check-version: version.h
	grep -q '\* === Version $(VERSION) ===' ChangeLog
	grep -q "^- === Version $(VERSION) ===" rhash.spec.in
#	[ ! -f debian/changelog ] || grep -q '^rhash ($(VERSION)-' debian/changelog
	grep -q '^#define VERSION "$(VERSION)"' version.h
	[ -s rhash.1.txt -a -s rhash.1.html ]

$(LIBRHASH): $(LIBRHASH_FILES)
	cd librhash && make lib-static

$(TARGET): $(OBJECTS) $(LIBRHASH)
	$(CC) $(OBJECTS) -o $(TARGET) $(LDFLAGS)

# NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
# we are using plain old makefile style to support BSD make
calc_sums.o: calc_sums.c librhash/hex.h librhash/rhash.h \
 librhash/torrent.h common_func.h librhash/util.h parse_cmdline.h \
 rhash_main.h file_set.h calc_sums.h crc_print.h output.h win_utils.h \
 version.h
	$(CC) -c $(CFLAGS) $< -o $@

common_func.o: common_func.c librhash/hex.h win_utils.h parse_cmdline.h \
 common_func.h librhash/util.h
	$(CC) -c $(CFLAGS) $< -o $@

crc_print.o: crc_print.c librhash/hex.h librhash/byte_order.h \
 common_func.h librhash/util.h calc_sums.h librhash/rhash.h \
 parse_cmdline.h crc_print.h
	$(CC) -c $(CFLAGS) $< -o $@

crc_update.o: crc_update.c common_func.h librhash/util.h win_utils.h \
 parse_cmdline.h output.h rhash_main.h file_set.h calc_sums.h \
 librhash/rhash.h file_mask.h crc_update.h
	$(CC) -c $(CFLAGS) $< -o $@

file_mask.o: file_mask.c common_func.h librhash/util.h file_mask.h
	$(CC) -c $(CFLAGS) $< -o $@

file_set.o: file_set.c librhash/hex.h librhash/crc32.h common_func.h \
 librhash/util.h crc_print.h parse_cmdline.h rhash_main.h output.h \
 file_set.h calc_sums.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

find_file.o: find_file.c common_func.h librhash/util.h win_utils.h \
 find_file.h
	$(CC) -c $(CFLAGS) $< -o $@

output.o: output.c librhash/rhash.h common_func.h librhash/util.h \
 calc_sums.h parse_cmdline.h rhash_main.h output.h
parse_cmdline.o: parse_cmdline.c librhash/rhash.h common_func.h \
 librhash/util.h win_utils.h file_mask.h output.h rhash_main.h version.h \
 parse_cmdline.h
	$(CC) -c $(CFLAGS) $< -o $@

rhash_main.o: rhash_main.c librhash/torrent.h common_func.h \
 librhash/util.h win_utils.h find_file.h file_set.h calc_sums.h \
 librhash/rhash.h crc_update.h file_mask.h crc_print.h parse_cmdline.h \
 output.h rhash_main.h
	$(CC) -c $(CFLAGS) $< -o $@

win_utils.o: win_utils.c common_func.h librhash/util.h version.h \
 parse_cmdline.h rhash_main.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

dist/rhash.1.html: rhash.1 rhash.1.win.sed
	sed -f rhash.1.win.sed rhash.1 | rman -fHTML -roff | \
	sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > dist/rhash.1.html

rhash.1.html: rhash.1
	-which rman &>/dev/null && (rman -fHTML -roff rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > rhash.1.html)

rhash.1.txt: rhash.1
	-which groff &>/dev/null && (groff -t -e -mandoc -Tascii rhash.1 | sed -e 's/.\[[0-9]*m//g' > rhash.1.txt)

cpp-doc:
	cppdoc_cmd -title=RHash -company=Animegorodok -classdir=classdoc -module="cppdoc-standard" -overwrite -extensions="c,h" -languages="c=cpp,h=cpp" -generate-deprecations-list=false $(SOURCES) $(HEADERS) ./Documentation/CppDoc/index.html

permissions: 
	chmod -x $(DIST_FILES)
	chmod +x tests/test_$(PROGNAME).sh

$(ARCHIVE_GZIP): $(DIST_FILES)
	make permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/
	tar czf $(ARCHIVE_GZIP) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_BZIP): $(DIST_FILES)
	make permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/
	tar cjf $(ARCHIVE_BZIP) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_7Z): $(DIST_FILES)
	make permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/
	tar cf - $(PROGNAME)-$(VERSION)/ | 7zr a -si $(ARCHIVE_7Z)
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.html rhash.1.txt
	[ -s dist/rhash.1.html -a -x $(TARGET) ]
	-rm -rf $(WIN_ZIP_DIR)
	mkdir $(WIN_ZIP_DIR)
	cp $(TARGET).exe dist/rhash.1.html rhash.1.txt ChangeLog $(WIN_DIST_FILES) $(WIN_ZIP_DIR)/
	-[ -f $(OUTDIR)libeay32.dll ] && cp $(OUTDIR)libeay32.dll $(WIN_ZIP_DIR)/
	zip -9r $(ARCHIVE_ZIP) $(WIN_ZIP_DIR)
	rm -rf $(WIN_ZIP_DIR)

$(ARCHIVE_DEB_GZ) : $(DIST_FILES)
	make $(ARCHIVE_GZIP)
	mv -f $(ARCHIVE_GZIP) $(ARCHIVE_DEB_GZ)

# packaging
$(SPECFILE): $(SPECFILE).in Makefile
	sed -e 's/@VERSION@/$(VERSION)/' $(SPECFILE).in > $(SPECFILE)

rpm: gzip
	-for i in $(RPMDIRS); do mkdir -p $(RPMTOP)/$$i; done
	cp -f $(ARCHIVE_GZIP) $(RPMTOP)/SOURCES
	rpmbuild -ba --clean --define "_topdir `pwd`/$(RPMTOP)" $(SPECFILE)
	mv -f `find $(RPMTOP) -name "rhash-*$(VERSION)*.rpm"` .
	rm -rf $(RPMTOP)

dist-clean: clean

clean:
	cd librhash && make clean
	rm -f *.o $(TARGET)

=== librhash/Makefile ===
# Samples of usage:
# compile with debug info: make OPTFLAGS=-g LDFLAGS= TARGET=rhash.debug
# compile for pentiumpro: make OPTFLAGS="-O2 -march=i586 -mcpu=pentiumpro"
# create rpm with statically linked program: make rpm LDFLAGS="-static -s -Wl,--gc-sections"
CC      = gcc
AR      = ar
#NOTE: NDEBUG turns off asserts, SHRFLAGS is used to make shared library
OPTFLAGS   = -O2 -DNDEBUG -fomit-frame-pointer -ffunction-sections -fdata-sections
OPTLDFLAGS =
SHRFLAGS   =
ADDCFLAGS  =
ADDLDFLAGS =
DEFFLAGS   = -DIN_RHASH
CFLAGS  := -pipe $(DEFFLAGS) $(ADDCFLAGS) $(OPTFLAGS) \
  -Wall -W -Wstrict-prototypes -Wnested-externs -Winline -Wpointer-arith \
  -Wbad-function-cast -Wmissing-prototypes -Wmissing-declarations
LDFLAGS = -L. -lrhash $(OPTLDFLAGS) $(ADDLDFLAGS)
HEADERS = algorithms.h aich.h timing.h byte_order.h plug_openssl.h rhash.h crc32.h util.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
SOURCES = algorithms.c aich.c timing.c byte_order.c plug_openssl.c rhash.c crc32.c util.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
OBJECTS = algorithms.o aich.o timing.o byte_order.o plug_openssl.o rhash.o crc32.o util.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
HEADERS_LIB = rhash.h timing.h
# installation directories and names
DESTDIR =
PREFIX  = /usr/local
INCDIR  = $(PREFIX)/include/rhash
LIBDIR  = $(PREFIX)/lib
LIBRARY = librhash.a
SONAME  = librhash.so.0
SOLINK  = librhash.so
TEST_TARGET = test_sums
TEST_SHARED = test_shared
# Set variables according to GNU coding standard
INSTALL = install
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SHARED  = $(INSTALL) -m 644

all: $(LIBRARY)
lib-static: $(LIBRARY)
lib-shared: $(SONAME)
dist-clean: clean

install-lib-static: $(LIBRARY)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR)
	$(INSTALL_DATA) $(LIBRARY) $(DESTDIR)$(LIBDIR)/
	$(INSTALL_DATA) $(HEADERS_LIB) $(DESTDIR)$(INCDIR)/
	ln -s $(SONAME) $(DESTDIR)$(LIBDIR)/$(SOLINK)

install-lib-shared: $(SONAME)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL_SHARED) $(SONAME) $(DESTDIR)$(LIBDIR)/

uninstall-lib-static:
	rm -f $(DESTDIR)$(LIBDIR)/$(LIBRARY) $(DESTDIR)$(INCDIR)/*.h
	rm -f $(DESTDIR)$(LIBDIR)/$(SOLINK)
	-rmdir $(DESTDIR)$(INCDIR)

uninstall-lib-shared:
	rm -f $(DESTDIR)$(LIBDIR)/$(SONAME)

install-all-headers:
	$(INSTALL_DATA) $(HEADERS) $(DESTDIR)$(INCDIR)/

# not using GNU make extensions for compatibility with Unix/*BSD make
#%.o: %.c
#	$(CC) -c $(CFLAGS) $< -o $@

# NOTE: dependences were generated by 'gcc -MM -DIN_RHASH *.c'
# we are using plain old makefile style to support BSD make
aich.o: aich.c byte_order.h config.h algorithms.h rhash.h aich.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

algorithms.o: algorithms.c byte_order.h config.h rhash.h algorithms.h \
 aich.h sha1.h crc32.h ed2k.h md4.h edonr.h gost.h has160.h md5.h \
 ripemd-160.h snefru.h sha256.h sha512.h tiger.h torrent.h util.h tth.h \
 whirlpool.h
	$(CC) -c $(CFLAGS) $< -o $@

byte_order.o: byte_order.c byte_order.h config.h
	$(CC) -c $(CFLAGS) $< -o $@

crc32.o: crc32.c byte_order.h config.h crc32.h
	$(CC) -c $(CFLAGS) $< -o $@

ed2k.o: ed2k.c ed2k.h md4.h
	$(CC) -c $(CFLAGS) $< -o $@

edonr.o: edonr.c byte_order.h config.h edonr.h
	$(CC) -c $(CFLAGS) $< -o $@

gost.o: gost.c byte_order.h config.h gost.h
	$(CC) -c $(CFLAGS) $< -o $@

has160.o: has160.c byte_order.h config.h has160.h
	$(CC) -c $(CFLAGS) $< -o $@

hex.o: hex.c hex.h
	$(CC) -c $(CFLAGS) $< -o $@

md4.o: md4.c byte_order.h config.h md4.h
	$(CC) -c $(CFLAGS) $< -o $@

md5.o: md5.c byte_order.h config.h md5.h
	$(CC) -c $(CFLAGS) $< -o $@

plug_openssl.o: plug_openssl.c algorithms.h rhash.h byte_order.h config.h \
 plug_openssl.h
	$(CC) -c $(CFLAGS) $< -o $@

rhash.o: rhash.c byte_order.h config.h algorithms.h rhash.h torrent.h \
 util.h sha1.h plug_openssl.h hex.h
	$(CC) -c $(CFLAGS) $< -o $@

ripemd-160.o: ripemd-160.c byte_order.h config.h ripemd-160.h
	$(CC) -c $(CFLAGS) $< -o $@

sha1.o: sha1.c byte_order.h config.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

sha256.o: sha256.c byte_order.h config.h sha256.h
	$(CC) -c $(CFLAGS) $< -o $@

sha512.o: sha512.c byte_order.h config.h sha512.h
	$(CC) -c $(CFLAGS) $< -o $@

snefru.o: snefru.c byte_order.h config.h snefru.h
	$(CC) -c $(CFLAGS) $< -o $@

test_sums.o: test_sums.c byte_order.h config.h timing.h rhash.h \
 test_sums.h
	$(CC) -c $(CFLAGS) $< -o $@

tiger.o: tiger.c byte_order.h config.h tiger.h
	$(CC) -c $(CFLAGS) $< -o $@

tiger_sbox.o: tiger_sbox.c byte_order.h config.h
	$(CC) -c $(CFLAGS) $< -o $@

timing.o: timing.c byte_order.h config.h rhash.h timing.h
	$(CC) -c $(CFLAGS) $< -o $@

torrent.o: torrent.c byte_order.h config.h algorithms.h rhash.h torrent.h \
 util.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

tth.o: tth.c byte_order.h config.h tth.h tiger.h
	$(CC) -c $(CFLAGS) $< -o $@

util.o: util.c util.h
	$(CC) -c $(CFLAGS) $< -o $@

whirlpool.o: whirlpool.c byte_order.h config.h whirlpool.h
	$(CC) -c $(CFLAGS) $< -o $@

whirlpool_sbox.o: whirlpool_sbox.c byte_order.h config.h
	$(CC) -c $(CFLAGS) $< -o $@

# MINGW dll target
DLLNAME = librhash.dll

dll: $(DLLNAME)
$(DLLNAME): $(SOURCES)
#	rm -f $@
	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' rhash.h timing.h > exports.sym
	$(CC) -shared -DRHASH_EXPORTS $(CFLAGS) -Wl,--version-script,exports.sym,-soname,$@ $(OPTLDFLAGS) $(SOURCES) -o $@

test-dll: $(DLLNAME) test_sums.o
	$(CC) test_sums.o $(DLLNAME) -o $(TEST_SHARED) && ./$(TEST_SHARED)

# shared and static libraries
$(SONAME): $(SOURCES)
#	rm -f $@
	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' rhash.h timing.h > exports.sym
	$(CC) -fpic -shared $(CFLAGS) -Wl,--version-script,exports.sym,-soname,$@ $(OPTLDFLAGS) $(SOURCES) -o $@
# use 'nm -Cg --defined-only $@' to view exported symbols

$(LIBRARY): $(OBJECTS)
	$(AR) cqs $@ $(OBJECTS)
#	$(AR) cr $(LIBRARY) $(OBJECTS) && runlib $(LIBRARY)

$(TEST_TARGET): $(LIBRARY) test_sums.o
	$(CC) test_sums.o $(LDFLAGS) -o $@

#$(TEST_SHARED): $(DLLNAME) test_sums.o
#	$(CC) test_sums.o $(DLLNAME) -o $@

test-shared: $(SONAME) test_sums.o
	$(CC) test_sums.o $(SONAME) $(LDFLAGS) -o $(TEST_SHARED)
	LD_LIBRARY_PATH=. ./$(TEST_SHARED)

test: $(TEST_TARGET)
	./$(TEST_TARGET)
	if [ -f $(SONAME) ]; then make test-shared; fi
#	if [ -f $(DLLNAME) ]; then make test-dll; fi

clean:
	rm -f *.o $(LIBRARY) $(TEST_TARGET) $(TEST_SHARED) $(SONAME) exports.sym

=== debian/changelog ===
rhash (1.2.6-2) unstable; urgency=low

  * Package compilation is fixed for several archs

 -- Alexey S Kravchenko <rhash.admin@gmail.com>  Thu, 30 Jun 2011 01:04:24 +0700

rhash (1.2.6-1) unstable; urgency=low

  * New upstream release version 1.2.6
   - ABI changed - now librhash0.0 is librhash0
   - OpenSSL support for faster hash calculation if libssl is installed
     (fully optional) for both rhash and librhash0

 -- Alexey S Kravchenko <rhash.admin@gmail.com>  Wed, 15 Jun 2011 01:03:34 +0700

rhash (1.2.5-1) unstable; urgency=low

  * Initial release (Closes: #629614)
  * The library SONAME was changed in the Debian package, see README.Debian

 -- Alexey S Kravchenko <rhash.admin@gmail.com>  Tue, 07 Jun 2011 22:46:05 +0700

=== debian/control ===
Source: rhash
Section: utils
Priority: optional
Maintainer: Alexey S Kravchenko <rhash.admin@gmail.com>
Build-Depends: debhelper (>= 8), libssl-dev (>= 1.0.0)
Standards-Version: 3.9.2
Homepage: http://rhash.sourceforge.net/
Vcs-Git: https://github.com/rhash/RHash.git
Vcs-Browser: https://github.com/rhash/RHash

Package: rhash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl (>= 1.0.0)
Description: utility for computing hash sums and magnet links
 RHash is a console utility for calculation and verification of magnet links
 and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Output in a predefined (SFV, BSD-like) or a user-defined format.
  * Can calculate Magnet links and EDonkey 2000 links.
  * Updating hash files (adding hash sums of files missing in the hash file).
  * Ability to process directories recursively.
  * Portability: the program works the same on Linux, *BSD or Windows.

Package: librhash0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl (>= 1.0.0)
Description: shared library for hash functions computing
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaniously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash-dev
Architecture: any
Section: libdevel
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: header files of librhash and static library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaniously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for librhash
 LibRHash is a professional, portable, thread-safe C library for computing 
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1/SHA2, AICH,
 ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaniously.
  * Portability: the library works on Linux, *BSD and Windows.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules makefile that uses debhelper.
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
OPTFLAGS = -Wall
INSTALL_PROGRAM = install -p -m 755
ADDCFLAGS =
ADDLDFLAGS =

# see Debian Policy Manual - source packages
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	OPTFLAGS += -O0 -DNDEBUG
else
	OPTFLAGS += -O2 -DNDEBUG -fomit-frame-pointer
endif
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	OPTFLAGS += -g
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

# by default compile with openssl runtime linking
ifeq (,$(findstring nossl,$(DEB_BUILD_OPTIONS)))
	ADDCFLAGS += -DUSE_OPENSSL
ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
	ADDLDFLAGS += -lcrypto
else
	ADDCFLAGS  += -DOPENSSL_RUNTIME -rdynamic
	ADDLDFLAGS += -ldl
endif
endif

# using debhelper >= 7 to build the package
%:
	dh $@

override_dh_auto_build:
	# Compile the package.
	$(MAKE) OPTFLAGS="$(OPTFLAGS)" OPTLDFLAGS= ADDCFLAGS="$(ADDCFLAGS)" ADDLDFLAGS="$(ADDLDFLAGS)" lib-shared all

override_dh_auto_test:
	$(MAKE) OPTFLAGS="$(OPTFLAGS)" ADDCFLAGS="$(ADDCFLAGS)" ADDLDFLAGS="$(ADDLDFLAGS)" test

override_dh_auto_install:
	# Install the program
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install
	# Install static library
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/librhash-dev install-lib-static
	# Install shared library
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/librhash0 install-lib-shared

override_dh_strip:
	dh_strip -prhash
	dh_strip -plibrhash0 --dbg-package=librhash0-dbg
